function [] = compare_fimtrack_results()
gt_path = './ground_truth/';
% gray Thresh: 80
tracking_path_80 = './tracking_grayThresh_80/';
% gray Thresh: 70
tracking_path_70 = './tracking_grayThresh_70/';
% gray Thresh: 60
tracking_path_60 = './tracking_grayThresh_60/';
% gray Thresh: 50
tracking_path_50 = './tracking_grayThresh_50/';
% gray Thresh: 40
tracking_path_40 = './tracking_grayThresh_40/';
% tray Thresh: 30:
tracking_path_30 = './tracking_grayThresh_30/';

gt_ds = readDataForAnalysis(gt_path);

% tracking_ds = readDataForAnalysis(tracking_path_80);
% tracking_ds = readDataForAnalysis(tracking_path_70);
% tracking_ds = readDataForAnalysis(tracking_path_60);
% tracking_ds = readDataForAnalysis(tracking_path_50);
% tracking_ds = readDataForAnalysis(tracking_path_40);
tracking_ds = readDataForAnalysis(tracking_path_30);

gt_mom_x = selectFeature(gt_ds, 'mass_x');
gt_mom_y = selectFeature(gt_ds, 'mass_y');

tr_mom_x = selectFeature(tracking_ds, 'mom_x');
tr_mom_y = selectFeature(tracking_ds, 'mom_y');

gt_mid_x = selectFeature(gt_ds, 'x_00003');
gt_mid_y = selectFeature(gt_ds, 'y_00003');

tr_mid_x = selectFeature(tracking_ds, 'spinepoint_3_x');
tr_mid_y = selectFeature(tracking_ds, 'spinepoint_3_y');

gt_mid_r = selectFeature(gt_ds, 'radius_00003');
tr_mid_r = selectFeature(tracking_ds, 'radius_3');



tr_area = selectFeature(tracking_ds, 'area');
mean_area = mean(nanmean(double(tr_area(:,2:end))/100));

tr_spine_length = selectFeature(tracking_ds, 'spine_length');
mean_spine_length = mean(nanmean(double(tr_spine_length(:,2:end))/10));


tr_bending = selectFeature(tracking_ds, 'bending');

gt_bending_mat = calcBendings( ...
    selectFeature(gt_ds, 'x_00000'), ...  % head x
    selectFeature(gt_ds, 'y_00000'), ...  % head y
    gt_mid_x, ...                         % mid x
    gt_mid_y, ...                         % mid y
    selectFeature(gt_ds, 'x_00006'), ...  % tail x
    selectFeature(gt_ds, 'y_00006'));     % tail y

gt_bending = gt_mid_r;
gt_bending.ID = tr_bending.ID;
gt_bending.larva0 = gt_bending_mat(:,1);
gt_bending.larva1 = gt_bending_mat(:,2);
gt_bending.larva2 = gt_bending_mat(:,3);
gt_bending.larva3 = gt_bending_mat(:,4);
gt_bending.larva4 = gt_bending_mat(:,5);
gt_bending.larva5 = gt_bending_mat(:,6);
gt_bending.larva6 = gt_bending_mat(:,7);
gt_bending.larva7 = gt_bending_mat(:,8);
gt_bending.larva8 = gt_bending_mat(:,9);
gt_bending.larva9 = gt_bending_mat(:,10);
gt_bending.larva10 = gt_bending_mat(:,11);
gt_bending.larva11 = gt_bending_mat(:,12);
gt_bending.larva12 = gt_bending_mat(:,13);
gt_bending.larva13 = gt_bending_mat(:,14);
gt_bending.larva14 = gt_bending_mat(:,15);

% gt        tracking    complete
% ------------------------------
% larva0    larva0      yes
% larva1    larva1      yes
% larva2    larva3      yes
% larva3    larva5      yes
% larva4    larva6      yes
% larva5    larva7      yes
% larva6    larva8      yes
% larva7    larva9      yes
% larva8    larva10     yes
% larva9    larva11     no
% larva10   larva13     yes
% larva11   larva14     yes
% larva12   larva12     no
% larva13   larva4      no
% larva14   larva2      no

id_pairs= { 'larva0','larva0'; ...
    'larva1','larva1'; ...
    'larva2','larva3'; ...
    %'larva3','larva5'; ...
    'larva4','larva6'; ...
    'larva5','larva7'; ...
    'larva6','larva8'; ...
    'larva7','larva9'; ...
    'larva8','larva10'; ...
    'larva10','larva13'; ...
    'larva11','larva14'};

% [mean_mom_devs, median_mom_devs, mom_stds, max_mom_devs, min_mom_devs] = getEuclDeviations(gt_mom_x, gt_mom_y, tr_mom_x, tr_mom_y, id_pairs);
% [mean_mid_devs, median_mid_devs, mid_stds, max_mid_devs, min_mid_devs] = getEuclDeviations(gt_mid_x, gt_mid_y, tr_mid_x, tr_mid_y, id_pairs);
% [mean_radius_devs, median_radius_devs, radius_stds, max_radius_devs, min_radius_devs] = getDeviations(gt_mid_r, tr_mid_r, id_pairs, 10);
% 
% [mean_bending_devs, median_bending_devs, bending_stds, max_bending_devs, min_bending_devs] = angleDeviation(gt_bending, tr_bending, id_pairs);

[all_mom_devs] = getEuclDeviations(gt_mom_x, gt_mom_y, tr_mom_x, tr_mom_y, id_pairs, 0);
[all_mid_devs] = getEuclDeviations(gt_mid_x, gt_mid_y, tr_mid_x, tr_mid_y, id_pairs, 0);
[all_radius_devs] = getDeviations(gt_mid_r, tr_mid_r, id_pairs, 10);

[all_bending_devs] = angleDeviation(gt_bending, tr_bending, id_pairs);

figure;
boxplot(all_mom_devs);

figure;
boxplot(all_mid_devs);

figure;
boxplot(all_bending_devs);

% disp(strcat('mean area: ', num2str(mean_area)));
% disp(strcat('mean spine length: ', num2str(mean_spine_length)));
% disp('---------------------------------------------------------');
% disp(strcat('mean momentum deviation: ', num2str(mean(mean_mom_devs)), ' pxls (std: ', num2str(mean(mom_stds)), ')'));
% disp(strcat('mean mid point deviation: ', num2str(mean(mean_mid_devs)), ' pxls (std: ', num2str(mean(mid_stds)), ')'));
% disp(strcat('mean mid radius deviation: ', num2str(mean(mean_radius_devs)), ' pxls (std: ', num2str(mean(radius_stds)), ')'));
% disp(strcat('median bending deviation: ', num2str(median(mean_bending_devs)), ' degree (std: ', num2str(median(bending_stds)), ')'));

end

function [all_devs, mean_devs, median_devs, stds, max_devs, min_devs] = getEuclDeviations(gt_x, gt_y, tr_x, tr_y, id_pairs, make_plot)
all_devs = zeros(size(tr_x, 1), size(id_pairs,1));
mean_devs = zeros(1,size(id_pairs,1));
median_devs = zeros(1,size(id_pairs,1));
stds = zeros(1,size(id_pairs,1));

max_devs = zeros(1,size(id_pairs,1));
min_devs = zeros(1,size(id_pairs,1));

% figure;
% hold on;

for i=1:size(id_pairs,1)
    gt_l_x = gt_x.(id_pairs{i,1});
    gt_l_y = gt_y.(id_pairs{i,1});
    
    tr_l_x = tr_x.(id_pairs{i,2});
    tr_l_y = tr_y.(id_pairs{i,2});
    
    if make_plot
        figure
        plot(gt_l_x, gt_l_y, 'b');
        hold on
        plot(tr_l_x, tr_l_y, 'r');
        title(strcat('Larva ', num2str(i)));
        hold off
    end
    
    devs = sqrt(pow2(gt_l_x - tr_l_x) + pow2(gt_l_y - tr_l_y));
    all_devs(:,i) = devs;
    
    mean_devs(1,i) = mean(sqrt(pow2(gt_l_x - tr_l_x) + pow2(gt_l_y - tr_l_y)));
    median_devs(1,i) = mean(sqrt(pow2(gt_l_x - tr_l_x) + pow2(gt_l_y - tr_l_y)));
    stds(1,i) = std(sqrt(pow2(gt_l_x - tr_l_x) + pow2(gt_l_y - tr_l_y)));
    
    max_devs(1,i) = max(sqrt(pow2(gt_l_x - tr_l_x) + pow2(gt_l_y - tr_l_y)));
    min_devs(1,i) = min(sqrt(pow2(gt_l_x - tr_l_x) + pow2(gt_l_y - tr_l_y)));
end

% hold off;
end

function [all_devs, mean_devs, median_devs, stds, max_devs, min_devs] = getDeviations(gt, tr, id_pairs, scale)
all_devs = zeros(size(tr, 1), size(id_pairs,1));
mean_devs = zeros(1,size(id_pairs,1));
median_devs = zeros(1,size(id_pairs,1));
stds = zeros(1,size(id_pairs,1));

max_devs = zeros(1,size(id_pairs,1));
min_devs = zeros(1,size(id_pairs,1));


for i=1:size(id_pairs,1)
    gt_l = gt.(id_pairs{i,1});
    
    tr_l = tr.(id_pairs{i,2});
    tr_l = tr_l /scale;
    
    devs = sqrt(pow2(gt_l - tr_l));
    all_devs(:,i) = devs;
    
    mean_devs(1,i) = mean(sqrt(pow2(gt_l - tr_l)));
    median_devs(1,i) = median(sqrt(pow2(gt_l - tr_l)));
    stds(1,i) = std(sqrt(pow2(gt_l - tr_l)));
    max_devs(1,i) = max(sqrt(pow2(gt_l - tr_l)));
    min_devs(1,i) = min(sqrt(pow2(gt_l - tr_l)));
end
end

function [all_devs, mean_devs, median_devs, stds, max_devs, min_devs] = angleDeviation(gt, tr, id_pairs)
all_devs = zeros(size(tr, 1), size(id_pairs,1));
mean_devs = zeros(1,size(id_pairs,1));
median_devs = zeros(1,size(id_pairs,1));
stds = zeros(1,size(id_pairs,1));
max_devs = zeros(1,size(id_pairs,1));
min_devs = zeros(1,size(id_pairs,1));

for i=1:size(id_pairs,1)
    gt_l = gt.(id_pairs{i,1});
    
    tr_l = tr.(id_pairs{i,2}); 
    
    devs = abs(gt_l - tr_l);
    devs(devs>180) = devs(devs>180) - 180;
    all_devs(:,i) = devs;
    
    mean_devs(1,i) = mean(abs(gt_l - tr_l));
    median_devs(1,i) = median(abs(gt_l - tr_l));
    stds(1,i) = std(abs(gt_l - tr_l));
    max_devs(1,i) = max(abs(gt_l - tr_l));
    min_devs(1,i) = min(abs(gt_l - tr_l));
end
end

function bending_angles = calcBendings(head_x, head_y, mid_x, mid_y, tail_x, tail_y)

p_x = double(mid_x(:,2:end));
p_y = double(mid_y(:,2:end));

p1_x = double(head_x(:,2:end));
p1_y = double(head_y(:,2:end));

p2_x = double(tail_x(:,2:end));
p2_y = double(tail_y(:,2:end));

bending_angles = zeros(size(p_x));

for larva_id=1:size(p_x, 2)
    p_x_vec = p_x(:,larva_id);
    p_y_vec = p_y(:,larva_id);
    
    p1_x_vec = p1_x(:,larva_id);
    p1_y_vec = p1_y(:,larva_id);
    
    p2_x_vec = p2_x(:,larva_id);
    p2_y_vec = p2_y(:,larva_id);
    
    for frame_num=1:size(p_x,1)
        p = [p_x_vec(frame_num) p_y_vec(frame_num)];
        p1 = [p1_x_vec(frame_num) p1_y_vec(frame_num)];
        p2 = [p2_x_vec(frame_num) p2_y_vec(frame_num)];
        
        l1 = p1 - p;
        l2 = p2 - p;
        
        norm1 = norm(l1,2);
        norm2 = norm(l2,2);
        
        testForNan = (l1(1)*l2(1) + l1(2)*l2(2)) / (norm1 * norm2);
        
        angle = 0.0;
        
        if(testForNan >= 1)
            angle = 0.0;
        elseif (testForNan <= -1)
            angle = 180.0;
        else
            angle = (acos( (l1(1)*l2(1) + l1(2)*l2(2)) / (norm1 * norm2) ) * 180 / pi);
        end
        
        sgn = (l1(1) * l2(2)) - (l1(2) * l2(1));
        
        if(sgn < 0)
            angle = 360 - angle;
        end
        
        bending_angles(frame_num, larva_id) = angle;
        
    end
    
end
end
